/*
    This file is part of MutekH.
    
    MutekH is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; version 2.1 of the
    License.
    
    MutekH is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with MutekH; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
    02110-1301 USA.

    Copyright (c) Nicolas Pouillon <nipo@ssji.net>, 2009

*/

#ifndef __ICU_SAM7_PRIVATE_H_
#define __ICU_SAM7_PRIVATE_H_

#include <device/class/icu.h>
#include <device/device.h>

struct icu_sam7_handler_s
{
  dev_irq_t		*hndl;
  void			*data;
};

#define ICU_SAM7_MAX_VECTOR	32

struct icu_sam7_private_s
{
	struct icu_sam7_handler_s	table[ICU_SAM7_MAX_VECTOR+1];
	uint_fast8_t virq_refcount;
};

#endif

