/*
  This file is part of MutekH.

  MutekH is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; version 2.1 of the
  License.
    
  MutekH is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
    
  You should have received a copy of the GNU Lesser General Public
  License along with MutekH; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
  02110-1301 USA

  Copyright Nicolas Pouillon, <nipo@ssji.net>, 2009
*/

#include <hexo/types.h>
#include <hexo/cpu.h>
#include <hexo/iospace.h>
#include <mutek/printk.h>
#include <mutek/startup.h>

static PRINTF_OUTPUT_FUNC(early_console_out)
{
	uintptr_t out = (uintptr_t)ctx;
	size_t i;
	for ( i=0; i<len; ++i )
		cpu_mem_write_8(out, str[i]);
}

static void soclib_early_console(uintptr_t addr)
{
	printk_set_output(early_console_out, (void*)addr);
}

void soclib_early_console_init()
{
	soclib_early_console(CONFIG_SOCLIB_EARLY_CONSOLE_ADDR);
}
