/*
    This file is part of libtermui.

    libtermui is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    libtermui is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libtermui.  If not, see <http://www.gnu.org/licenses/>.

    Copyright 2006, Alexandre Becoulet <alexandre.becoulet@free.fr>

*/

#ifndef TERMUI_STRINGS_H_
#define TERMUI_STRINGS_H_

#include <termui/types.h>

/** @this is usefull to find strings matching lenght for use in completion handlers. */
termui_strlen_t termui_str_match_len(const char *a, const char *b);

/** @this matchs non terminated pattern string against name string. Pattern is anchored at name start only. */
termui_bool_t termui_str_match(const char *pstart, const char *pend, const char *name);

/** @this matchs non terminated sub string in name string. */
termui_bool_t termui_str_strstr(const char *pstart, const char *pend, const char *name);

#endif
