#ifndef __STDIO_H
#define __STDIO_H

/*
  The function printk writes the string str to the TTY
  according to a format described below.
  
  The conversion specifiers and their meanings are :
  b    the unsigned int argument is converted to unsigned binary.

  c    the int argument is converted to an unsigned char and 
       the resulting character is written.
  
  d    the int argument is converted to signed decimal notation.

  p    the void * pointer argument is printed in hexadecimal

  s    the const char * argument is expected to be a pointer
       to an array of character type (pointer to a string).
       Characteres from the array are written up to a 
       terminating null byte ('\0').
  
  x, X the unsigned int argument is converted to unsigned 
       hexadecimal.
    
  @param str const char* the formated string to print
 */
void printk(const char *str, ...);

#endif
