#ifndef __STRING_H
#define __STRING_H

#include "types.h"

/*
  memcpy function with aligned address

  @param void * _dst : pointer of the destination
  @param const void * _src : pointer of the source
  @param unsigned int size : size to copy from the source to the destination
  @return void * : pointer of the destination
 */
void *memcpy(void *dst, void const *src, uint32_t len);

/*
  convert an integer to a string
 
  @param int value : value to convert
  @param char *dst : string destination
  @param int base : base to use
 
  @return char* : pointer of the string
 */
char *itoa(int value, char *dst, int base);

#endif
