#ifndef __MEMORY_FOOTPRINT_H

/*
  memory structure used as argument when loading the kernel

  - what kind of SP have been created
  - slave pspe used for mac
  - slave pspe used for ht

  - stack address
  - stack size

  - the flat device tree when supported
 */

struct memory_footprint_s
{
  uint32_t sp[9]; // only 9 sp can be used by the bootloader

  uint32_t slave_mac_addr;
  uint32_t slave_ht_addr;

  uint32_t stack_addr;
  uint32_t stack_size;

  uint32_t heap_start_addr;
};

#endif
