/* -*- c++ -*-
 *
 * SOCLIB_LGPL_HEADER_BEGIN
 * 
 * This file is part of SoCLib, GNU LGPLv2.1.
 * 
 * SoCLib is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; version 2.1 of the License.
 * 
 * SoCLib is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with SoCLib; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA
 * 
 * SOCLIB_LGPL_HEADER_END
 *
 * Copyright (c) UPMC, Lip6, Asim
 *         Nicolas Pouillon <nipo@ssji.net>, 2007
 *
 * Maintainers: nipo
 */
#ifndef SOCLIB_PROCESS_WRAPPER_H_
#define SOCLIB_PROCESS_WRAPPER_H_

#include <sys/types.h>
#include "fd_poller.h"
#include <string>
#include <vector>

namespace soclib { namespace common {

class ProcessWrapper
{
    pid_t m_pid;
    int m_fd_to_process;
    int m_fd_from_process;
    FdPoller m_poller;

public:
    ProcessWrapper(
        const std::string &cmd,
        const std::vector<std::string> &argv );
    
    ~ProcessWrapper();

    ssize_t read( void *buffer, size_t len, bool block = false );
    ssize_t write( const void *buffer, size_t len, bool block = false );
    bool poll();
    void kill(int sig);
};

}}

#endif /* SOCLIB_PROCESS_WRAPPER_H_ */

// Local Variables:
// tab-width: 4
// c-basic-offset: 4
// c-file-offsets:((innamespace . 0)(inline-open . 0))
// indent-tabs-mode: nil
// End:

// vim: filetype=cpp:expandtab:shiftwidth=4:tabstop=4:softtabstop=4

